"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AddButton = AddButton;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _FlowContext = require("./FlowContext");

var _nodes = require("./nodes");

var _style = require("./style");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

;

function AddButton({
  upstream,
  branchIndex = null
}) {
  var _useFlowContext;

  const compile = (0, _client().useCompile)();
  const api = (0, _client().useAPIClient)();

  const _ref = (_useFlowContext = (0, _FlowContext.useFlowContext)()) !== null && _useFlowContext !== void 0 ? _useFlowContext : {},
        workflow = _ref.workflow,
        onNodeAdded = _ref.onNodeAdded;

  if (!workflow) {
    return null;
  }

  const resource = api.resource('workflows.nodes', workflow.id);

  function onCreate(_x) {
    return _onCreate.apply(this, arguments);
  }

  function _onCreate() {
    _onCreate = _asyncToGenerator(function* ({
      keyPath
    }) {
      var _upstream$id;

      const type = keyPath.pop();
      const config = {};

      const _keyPath = _slicedToArray(keyPath, 1),
            optionKey = _keyPath[0];

      if (optionKey) {
        const _instructions$get$opt = _nodes.instructions.get(type).options.find(item => item.key === optionKey),
              value = _instructions$get$opt.value;

        Object.assign(config, value);
      }

      const _yield$resource$creat = yield resource.create({
        values: {
          type,
          upstreamId: (_upstream$id = upstream === null || upstream === void 0 ? void 0 : upstream.id) !== null && _upstream$id !== void 0 ? _upstream$id : null,
          branchIndex,
          config
        }
      }),
            node = _yield$resource$creat.data.data;

      onNodeAdded(node);
    });
    return _onCreate.apply(this, arguments);
  }

  const groups = [{
    value: 'control',
    name: '{{t("Control")}}'
  }, {
    value: 'collection',
    name: '{{t("Collection operations")}}'
  }];
  const instructionList = Array.from(_nodes.instructions.getValues());
  return _react().default.createElement("div", {
    className: (0, _css().cx)(_style.addButtonClass)
  }, _react().default.createElement(_antd().Dropdown, {
    trigger: ['click'],
    overlay: _react().default.createElement(_antd().Menu, {
      onClick: ev => onCreate(ev)
    }, groups.map(group => _react().default.createElement(_antd().Menu.ItemGroup, {
      key: group.value,
      title: compile(group.name)
    }, instructionList.filter(item => item.group === group.value).map(item => item.options ? _react().default.createElement(_antd().Menu.SubMenu, {
      key: item.type,
      title: compile(item.title)
    }, item.options.map(option => _react().default.createElement(_antd().Menu.Item, {
      key: option.key
    }, compile(option.label)))) : _react().default.createElement(_antd().Menu.Item, {
      key: item.type
    }, compile(item.title)))))),
    disabled: workflow.executed
  }, _react().default.createElement(_antd().Button, {
    shape: "circle",
    icon: _react().default.createElement(_icons().PlusOutlined, null)
  })));
}

;