"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExecutionCanvas = ExecutionCanvas;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function _reactRouterDom() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

function _client2() {
  const data = require("@nocobase/utils/client");

  _client2 = function _client2() {
    return data;
  };

  return data;
}

var _FlowContext = require("./FlowContext");

var _style = require("./style");

var _triggers = require("./triggers");

var _Branch = require("./Branch");

var _constants = require("./constants");

const _excluded = ["nodes", "revisions"],
      _excluded2 = ["jobs", "workflow"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function makeNodes(nodes, jobs = []) {
  const nodesMap = new Map();
  nodes.forEach(item => nodesMap.set(item.id, item));
  const jobsMap = new Map();
  jobs.forEach(item => jobsMap.set(item.nodeId, item));

  var _iterator = _createForOfIteratorHelper(nodesMap.values()),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      let node = _step.value;

      if (node.upstreamId) {
        node.upstream = nodesMap.get(node.upstreamId);
      }

      if (node.downstreamId) {
        node.downstream = nodesMap.get(node.downstreamId);
      }

      if (jobsMap.has(node.id)) {
        node.job = jobsMap.get(node.id);
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}

function ExecutionCanvas() {
  var _data$data2;

  const _useTranslation = (0, _reactI18next().useTranslation)(),
        t = _useTranslation.t;

  const compile = (0, _client().useCompile)();

  const _useResourceActionCon = (0, _client().useResourceActionContext)(),
        data = _useResourceActionCon.data,
        refresh = _useResourceActionCon.refresh,
        loading = _useResourceActionCon.loading;

  const _useDocumentTitle = (0, _client().useDocumentTitle)(),
        setTitle = _useDocumentTitle.setTitle;

  (0, _react().useEffect)(() => {
    var _data$data;

    const _ref = (_data$data = data === null || data === void 0 ? void 0 : data.data) !== null && _data$data !== void 0 ? _data$data : {},
          workflow = _ref.workflow;

    setTitle(`${(workflow === null || workflow === void 0 ? void 0 : workflow.title) ? `${workflow.title} - ` : ''}${t('Execution history')}`);
  }, [data === null || data === void 0 ? void 0 : data.data]);

  if (!(data === null || data === void 0 ? void 0 : data.data)) {
    if (loading) {
      return _react().default.createElement("div", null, t('Loading'));
    } else {
      return _react().default.createElement("div", null, t('Load failed'));
    }
  }

  const _ref2 = (_data$data2 = data === null || data === void 0 ? void 0 : data.data) !== null && _data$data2 !== void 0 ? _data$data2 : {},
        _ref2$jobs = _ref2.jobs,
        jobs = _ref2$jobs === void 0 ? [] : _ref2$jobs,
        _ref2$workflow = _ref2.workflow,
        _ref2$workflow2 = _ref2$workflow === void 0 ? {} : _ref2$workflow,
        _ref2$workflow2$nodes = _ref2$workflow2.nodes,
        nodes = _ref2$workflow2$nodes === void 0 ? [] : _ref2$workflow2$nodes,
        _ref2$workflow2$revis = _ref2$workflow2.revisions,
        revisions = _ref2$workflow2$revis === void 0 ? [] : _ref2$workflow2$revis,
        workflow = _objectWithoutProperties(_ref2$workflow2, _excluded),
        execution = _objectWithoutProperties(_ref2, _excluded2);

  makeNodes(nodes, jobs);
  const entry = nodes.find(item => !item.upstream);
  const statusOption = _constants.ExecutionStatusOptionsMap[execution.status];
  return _react().default.createElement(_FlowContext.FlowContext.Provider, {
    value: {
      workflow: workflow.type ? workflow : null,
      nodes,
      execution
    }
  }, _react().default.createElement("div", {
    className: "workflow-toolbar"
  }, _react().default.createElement("header", null, _react().default.createElement("span", null, _react().default.createElement(_reactRouterDom().Link, {
    to: `/admin/settings/workflow/workflows`
  }, t('Workflow'))), _react().default.createElement("span", null, _react().default.createElement(_reactRouterDom().Link, {
    to: `/admin/settings/workflow/workflows/${workflow.id}`
  }, workflow.title)), _react().default.createElement("strong", null, `#${execution.id}`)), _react().default.createElement("aside", null, _react().default.createElement(_antd().Tag, {
    color: statusOption.color
  }, compile(statusOption.label)), _react().default.createElement("time", null, (0, _client2().str2moment)(execution.updatedAt).format('YYYY-MM-DD HH:mm:ss')))), _react().default.createElement("div", {
    className: "workflow-canvas"
  }, _react().default.createElement(_triggers.TriggerConfig, null), _react().default.createElement("div", {
    className: _style.branchBlockClass
  }, _react().default.createElement(_Branch.Branch, {
    entry: entry
  })), _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeCardClass)
  }, _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeMetaClass)
  }, _react().default.createElement(_antd().Tag, {
    color: "#333"
  }, t('End'))))));
}