"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExecutionPage = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function _reactRouterDom() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _style = require("./style");

var _ExecutionCanvas = require("./ExecutionCanvas");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ExecutionPage = () => {
  const _useRouteMatch = (0, _reactRouterDom().useRouteMatch)(),
        params = _useRouteMatch.params;

  return _react().default.createElement("div", {
    className: (0, _css().cx)(_style.workflowPageClass)
  }, _react().default.createElement(_client().SchemaComponent, {
    schema: {
      type: 'void',
      properties: {
        [`execution_${params.id}`]: {
          type: 'void',
          'x-decorator': 'ResourceActionProvider',
          'x-decorator-props': {
            collection: {
              name: 'executions',
              fields: []
            },
            resourceName: 'executions',
            request: {
              resource: 'executions',
              action: 'get',
              params: {
                filter: params,
                appends: ['jobs', 'workflow', 'workflow.nodes']
              }
            }
          },
          'x-component': 'ExecutionCanvas'
        }
      }
    },
    components: {
      ExecutionCanvas: _ExecutionCanvas.ExecutionCanvas
    }
  }));
};

exports.ExecutionPage = ExecutionPage;