"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WorkflowCanvas = WorkflowCanvas;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function _reactRouterDom() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _classnames() {
  const data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _FlowContext = require("./FlowContext");

var _style = require("./style");

var _triggers = require("./triggers");

var _Branch = require("./Branch");

const _excluded = ["nodes", "revisions"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function makeNodes(nodes) {
  const nodesMap = new Map();
  nodes.forEach(item => nodesMap.set(item.id, item));

  var _iterator = _createForOfIteratorHelper(nodesMap.values()),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      let node = _step.value;

      if (node.upstreamId) {
        node.upstream = nodesMap.get(node.upstreamId);
      }

      if (node.downstreamId) {
        node.downstream = nodesMap.get(node.downstreamId);
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}

function WorkflowCanvas() {
  var _data$data2;

  const _useTranslation = (0, _reactI18next().useTranslation)(),
        t = _useTranslation.t;

  const history = (0, _reactRouterDom().useHistory)();

  const _useResourceActionCon = (0, _client().useResourceActionContext)(),
        data = _useResourceActionCon.data,
        refresh = _useResourceActionCon.refresh,
        loading = _useResourceActionCon.loading;

  const _useResourceContext = (0, _client().useResourceContext)(),
        resource = _useResourceContext.resource,
        targetKey = _useResourceContext.targetKey;

  const _useDocumentTitle = (0, _client().useDocumentTitle)(),
        setTitle = _useDocumentTitle.setTitle;

  (0, _react().useEffect)(() => {
    var _data$data;

    const _ref = (_data$data = data === null || data === void 0 ? void 0 : data.data) !== null && _data$data !== void 0 ? _data$data : {},
          title = _ref.title;

    setTitle(`${t('Workflow')}${title ? `: ${title}` : ''}`);
  }, [data === null || data === void 0 ? void 0 : data.data]);

  if (!(data === null || data === void 0 ? void 0 : data.data) && !loading) {
    return _react().default.createElement("div", null, t('Load failed'));
  }

  const _ref2 = (_data$data2 = data === null || data === void 0 ? void 0 : data.data) !== null && _data$data2 !== void 0 ? _data$data2 : {},
        _ref2$nodes = _ref2.nodes,
        nodes = _ref2$nodes === void 0 ? [] : _ref2$nodes,
        _ref2$revisions = _ref2.revisions,
        revisions = _ref2$revisions === void 0 ? [] : _ref2$revisions,
        workflow = _objectWithoutProperties(_ref2, _excluded);

  makeNodes(nodes);
  const entry = nodes.find(item => !item.upstream);

  function onSwitchVersion({
    key
  }) {
    if (key != workflow.id) {
      history.push(key);
    }
  }

  function onToggle(_x) {
    return _onToggle.apply(this, arguments);
  }

  function _onToggle() {
    _onToggle = _asyncToGenerator(function* (value) {
      yield resource.update({
        filterByTk: workflow[targetKey],
        values: {
          enabled: value,
          // NOTE: keep `key` field to adapt for backend
          key: workflow.key
        }
      });
      refresh();
    });
    return _onToggle.apply(this, arguments);
  }

  function onRevision() {
    return _onRevision.apply(this, arguments);
  }

  function _onRevision() {
    _onRevision = _asyncToGenerator(function* () {
      const _yield$resource$revis = yield resource.revision({
        filterByTk: workflow[targetKey]
      }),
            revision = _yield$resource$revis.data.data;

      _antd().message.success(t('Operation succeeded'));

      history.push(`${revision.id}`);
    });
    return _onRevision.apply(this, arguments);
  }

  return _react().default.createElement(_FlowContext.FlowContext.Provider, {
    value: {
      workflow,
      nodes,
      onNodeAdded: refresh,
      onNodeRemoved: refresh
    }
  }, _react().default.createElement("div", {
    className: "workflow-toolbar"
  }, _react().default.createElement("header", null, _react().default.createElement("span", null, _react().default.createElement(_reactRouterDom().Link, {
    to: `/admin/settings/workflow/workflows`
  }, t('Workflow'))), _react().default.createElement("strong", null, workflow.title)), _react().default.createElement("aside", null, _react().default.createElement("div", {
    className: "workflow-versions"
  }, _react().default.createElement("label", null, t('Version')), _react().default.createElement(_antd().Dropdown, {
    trigger: ['click'],
    overlay: _react().default.createElement(_antd().Menu, {
      onClick: onSwitchVersion,
      defaultSelectedKeys: [workflow.id],
      className: (0, _css().cx)(_style.workflowVersionDropdownClass)
    }, revisions.sort((a, b) => b.id - a.id).map((item, index) => _react().default.createElement(_antd().Menu.Item, {
      key: item.id,
      icon: item.current ? _react().default.createElement(_icons().RightOutlined, null) : null,
      className: (0, _classnames().default)({
        executed: item.executed,
        unexecuted: !item.executed,
        enabled: item.enabled
      })
    }, _react().default.createElement("strong", null, `#${item.id}`), _react().default.createElement("time", null, new Date(item.createdAt).toLocaleString()))))
  }, _react().default.createElement(_antd().Button, {
    type: "link"
  }, (workflow === null || workflow === void 0 ? void 0 : workflow.id) ? `#${workflow.id}` : null, _react().default.createElement(_icons().DownOutlined, null)))), _react().default.createElement(_antd().Switch, {
    checked: workflow.enabled,
    onChange: onToggle,
    checkedChildren: t('On'),
    unCheckedChildren: t('Off')
  }), workflow.executed && !revisions.find(item => !item.executed && new Date(item.createdAt) > new Date(workflow.createdAt)) ? _react().default.createElement(_antd().Button, {
    onClick: onRevision
  }, t('Copy to new version')) : null)), _react().default.createElement("div", {
    className: "workflow-canvas"
  }, _react().default.createElement(_triggers.TriggerConfig, null), _react().default.createElement("div", {
    className: _style.branchBlockClass
  }, _react().default.createElement(_Branch.Branch, {
    entry: entry
  })), _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeCardClass)
  }, _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeMetaClass)
  }, _react().default.createElement(_antd().Tag, {
    color: "#333"
  }, t('End'))))));
}