"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WorkflowPage = void 0;

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function _reactRouterDom() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _style = require("./style");

var _WorkflowCanvas = require("./WorkflowCanvas");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const WorkflowPage = () => {
  const _useRouteMatch = (0, _reactRouterDom().useRouteMatch)(),
        params = _useRouteMatch.params;

  return _react().default.createElement("div", {
    className: (0, _css().cx)(_style.workflowPageClass)
  }, _react().default.createElement(_client().SchemaComponent, {
    schema: {
      type: 'void',
      properties: {
        [`provider_${params.id}`]: {
          type: 'void',
          'x-decorator': 'ResourceActionProvider',
          'x-decorator-props': {
            collection: {
              name: 'workflows',
              fields: []
            },
            resourceName: 'workflows',
            request: {
              resource: 'workflows',
              action: 'get',
              params: {
                filter: params,
                appends: ['nodes', 'revisions.id', 'revisions.createdAt', 'revisions.current', 'revisions.executed', 'revisions.enabled']
              }
            }
          },
          'x-component': 'WorkflowCanvas'
        }
      }
    },
    components: {
      WorkflowCanvas: _WorkflowCanvas.WorkflowCanvas
    }
  }));
};

exports.WorkflowPage = WorkflowPage;