"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WorkflowShortcut = exports.WorkflowPane = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function _reactRouterDom() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _workflows = require("./schemas/workflows");

var _WorkflowLink = require("./WorkflowLink");

var _ExecutionResourceProvider = require("./ExecutionResourceProvider");

var _ExecutionLink = require("./ExecutionLink");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const WorkflowPane = () => {
  return _react().default.createElement(_antd().Card, {
    bordered: false
  }, _react().default.createElement(_client().SchemaComponent, {
    schema: _workflows.workflowSchema,
    components: {
      WorkflowLink: _WorkflowLink.WorkflowLink,
      ExecutionResourceProvider: _ExecutionResourceProvider.ExecutionResourceProvider,
      ExecutionLink: _ExecutionLink.ExecutionLink
    }
  }));
};

exports.WorkflowPane = WorkflowPane;

const WorkflowShortcut = () => {
  const _useTranslation = (0, _reactI18next().useTranslation)(),
        t = _useTranslation.t;

  const history = (0, _reactRouterDom().useHistory)();
  return _react().default.createElement(_client().PluginManager.Toolbar.Item, {
    icon: _react().default.createElement(_icons().PartitionOutlined, null),
    title: t('Workflow'),
    onClick: () => {
      history.push('/admin/settings/workflow/workflows');
    }
  });
};

exports.WorkflowShortcut = WorkflowShortcut;