"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(props) {
  const collection = props.collection,
        value = props.value,
        onChange = props.onChange;

  const _useTranslation = (0, _reactI18next().useTranslation)(),
        t = _useTranslation.t;

  const compile = (0, _client().useCompile)();

  const _useCollectionManager = (0, _client().useCollectionManager)(),
        getCollectionFields = _useCollectionManager.getCollectionFields;

  const fields = getCollectionFields(collection).filter(field => field.interface && (!field.target || field.type === 'belongsTo')).map(field => {
    var _field$uiSchema, _field$uiSchema2;

    return field.type === 'belongsTo' ? {
      title: `${compile(((_field$uiSchema = field.uiSchema) === null || _field$uiSchema === void 0 ? void 0 : _field$uiSchema.title) || field.name)} ID`,
      name: field.foreignKey
    } : {
      title: compile(((_field$uiSchema2 = field.uiSchema) === null || _field$uiSchema2 === void 0 ? void 0 : _field$uiSchema2.title) || field.name),
      name: field.name
    };
  });
  return _react().default.createElement(_antd().Select, {
    placeholder: t('Fields'),
    value: value,
    onChange: onChange
  }, fields.map(field => _react().default.createElement(_antd().Select.Option, {
    key: field.name,
    value: field.name
  }, field.title)));
}

function SelectWithAssociations(props) {
  const collection = props.collection,
        value = props.value,
        onChange = props.onChange;

  const _useTranslation2 = (0, _reactI18next().useTranslation)(),
        t = _useTranslation2.t;

  const compile = (0, _client().useCompile)();
  const fields = (0, _client().useCollectionFilterOptions)(collection);
  return _react().default.createElement(_antd().Cascader, {
    fieldNames: {
      label: 'title',
      value: 'name',
      children: 'children'
    },
    changeOnSelect: false,
    value: Array.isArray(value) ? value : value === null || value === void 0 ? void 0 : value.split('.'),
    options: compile(fields),
    onChange: onChange,
    placeholder: t('Select Field')
  });
}