"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JobStatusOptionsMap = exports.JobStatusOptions = exports.JOB_STATUS = exports.ExecutionStatusOptionsMap = exports.ExecutionStatusOptions = exports.EXECUTION_STATUS = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const EXECUTION_STATUS = {
  QUEUEING: null,
  STARTED: 0,
  SUCCEEDED: 1,
  FAILED: -1,
  CANCELED: -2
};
exports.EXECUTION_STATUS = EXECUTION_STATUS;
const ExecutionStatusOptions = [{
  value: EXECUTION_STATUS.QUEUEING,
  label: '{{t("Queueing")}}',
  color: 'blue'
}, {
  value: EXECUTION_STATUS.STARTED,
  label: '{{t("On going")}}',
  color: 'gold'
}, {
  value: EXECUTION_STATUS.SUCCEEDED,
  label: '{{t("Succeeded")}}',
  color: 'green'
}, {
  value: EXECUTION_STATUS.FAILED,
  label: '{{t("Failed")}}',
  color: 'red'
}, {
  value: EXECUTION_STATUS.CANCELED,
  label: '{{t("Canceled")}}'
}];
exports.ExecutionStatusOptions = ExecutionStatusOptions;
const ExecutionStatusOptionsMap = ExecutionStatusOptions.reduce((map, option) => Object.assign(map, {
  [option.value]: option
}), {});
exports.ExecutionStatusOptionsMap = ExecutionStatusOptionsMap;
const JOB_STATUS = {
  PENDING: 0,
  RESOLVED: 1,
  REJECTED: -1,
  CANCELED: -2
};
exports.JOB_STATUS = JOB_STATUS;
const JobStatusOptions = [{
  value: JOB_STATUS.PENDING,
  label: '{{t("Pending")}}',
  color: '#d4c306',
  icon: _react().default.createElement(_icons().ClockCircleOutlined, null)
}, {
  value: JOB_STATUS.RESOLVED,
  label: '{{t("Succeeded")}}',
  color: '#67c068',
  icon: _react().default.createElement(_icons().CheckOutlined, null)
}, {
  value: JOB_STATUS.REJECTED,
  label: '{{t("Failed")}}',
  color: '#f40',
  icon: _react().default.createElement(_icons().ExclamationOutlined, null)
}, {
  value: JOB_STATUS.CANCELED,
  label: '{{t("Canceled")}}',
  color: '#f40',
  icon: _react().default.createElement(_icons().CloseOutlined, null)
}];
exports.JobStatusOptions = JobStatusOptions;
const JobStatusOptionsMap = JobStatusOptions.reduce((map, option) => Object.assign(map, {
  [option.value]: option
}), {});
exports.JobStatusOptionsMap = JobStatusOptionsMap;