"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _ = require(".");

var _Branch = require("../Branch");

var _FlowContext = require("../FlowContext");

var _style = require("../style");

var _calculators = require("../calculators");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function CalculationItem({
  value,
  onChange: _onChange,
  onRemove
}) {
  if (!value) {
    return null;
  }

  const calculator = value.calculator,
        _value$operands = value.operands,
        operands = _value$operands === void 0 ? [] : _value$operands;
  return _react().default.createElement("div", {
    className: (0, _css().css)`
      display: flex;
      position: relative;
      margin: .5em 0;
    `
  }, value.group ? _react().default.createElement(CalculationGroup, {
    value: value.group,
    onChange: group => _onChange(_objectSpread(_objectSpread({}, value), {}, {
      group
    }))
  }) : _react().default.createElement(_calculators.Calculation, {
    operands: operands,
    calculator: calculator,
    onChange: _onChange
  }), _react().default.createElement(_antd().Button, {
    onClick: onRemove,
    type: "link",
    icon: _react().default.createElement(_icons().CloseCircleOutlined, null)
  }));
}

function CalculationGroup({
  value,
  onChange: _onChange2
}) {
  const _useTranslation = (0, _reactI18next().useTranslation)(),
        t = _useTranslation.t;

  const _value$type = value.type,
        type = _value$type === void 0 ? 'and' : _value$type,
        _value$calculations = value.calculations,
        calculations = _value$calculations === void 0 ? [] : _value$calculations;

  function onAddSingle() {
    _onChange2(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations, {
        not: false,
        calculator: 'equal'
      }]
    }));
  }

  function onAddGroup() {
    _onChange2(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations, {
        not: false,
        group: {
          type: 'and',
          calculations: []
        }
      }]
    }));
  }

  function _onRemove(i) {
    calculations.splice(i, 1);

    _onChange2(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations]
    }));
  }

  function onItemChange(i, v) {
    calculations.splice(i, 1, v);

    _onChange2(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations]
    }));
  }

  return _react().default.createElement("div", {
    className: (0, _css().cx)('node-type-condition-group', (0, _css().css)`
      position: relative;
      width: 100%;

      .node-type-condition-group{
        padding: .5em 1em;
        border: 1px dashed #ddd;
      }

      + button{
        position: absolute;
        right: 0;
      }
    `)
  }, _react().default.createElement("div", {
    className: (0, _css().css)`
        display: flex;
        align-items: center;
        gap: .5em;

        .ant-select{
          width: auto;
          min-width: 6em;
        }
      `
  }, _react().default.createElement(_reactI18next().Trans, null, 'Meet ', _react().default.createElement(_antd().Select, {
    value: type,
    onChange: t => _onChange2(_objectSpread(_objectSpread({}, value), {}, {
      type: t
    }))
  }, _react().default.createElement(_antd().Select.Option, {
    value: "and"
  }, "All"), _react().default.createElement(_antd().Select.Option, {
    value: "or"
  }, "Any")), ' conditions in the group')), _react().default.createElement("div", {
    className: "calculation-items"
  }, calculations.map((calculation, i) => _react().default.createElement(CalculationItem, {
    key: `${calculation.calculator}_${i}`,
    value: calculation,
    onChange: onItemChange.bind(this, i),
    onRemove: () => _onRemove(i)
  }))), _react().default.createElement("div", {
    className: (0, _css().css)`
        button{
          padding: 0;

          &:not(:last-child){
            margin-right: 1em;
          }
        }
      `
  }, _react().default.createElement(_antd().Button, {
    type: "link",
    onClick: onAddSingle
  }, t('Add condition')), _react().default.createElement(_antd().Button, {
    type: "link",
    onClick: onAddGroup
  }, t('Add condition group'))));
}

function CalculationConfig({
  value,
  onChange: _onChange3
}) {
  const rule = value && Object.keys(value).length ? value : {
    group: {
      type: 'and',
      calculations: []
    }
  };
  return _react().default.createElement(CalculationGroup, {
    value: rule.group,
    onChange: group => _onChange3(_objectSpread(_objectSpread({}, rule), {}, {
      group
    }))
  });
}

var _default = {
  title: '{{t("Condition")}}',
  type: 'condition',
  group: 'control',
  fieldset: {
    'config.rejectOnFalse': {
      type: 'boolean',
      name: 'config.rejectOnFalse',
      title: '{{t("Mode")}}',
      'x-decorator': 'FormItem',
      'x-component': 'Radio.Group',
      'x-component-props': {
        disabled: true
      },
      enum: [{
        value: true,
        label: _client().i18n.t('Continue when "Yes"')
      }, {
        value: false,
        label: _client().i18n.t('Branch into "Yes" and "No"')
      }]
    },
    'config.calculation': {
      type: 'string',
      name: 'config.calculation',
      title: '{{t("Conditions")}}',
      'x-decorator': 'FormItem',
      'x-component': 'CalculationConfig'
    }
  },
  view: {},
  options: [{
    label: _client().i18n.t('Continue when "Yes"'),
    key: 'rejectOnFalse',
    value: {
      rejectOnFalse: true
    }
  }, {
    label: _client().i18n.t('Branch into "Yes" and "No"'),
    key: 'branch',
    value: {
      rejectOnFalse: false
    }
  }],

  render(data) {
    const id = data.id,
          rejectOnFalse = data.config.rejectOnFalse;

    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
          nodes = _useFlowContext.nodes;

    const trueEntry = nodes.find(item => item.upstreamId === id && item.branchIndex === 1);
    const falseEntry = nodes.find(item => item.upstreamId === id && item.branchIndex === 0);
    return _react().default.createElement(_.NodeDefaultView, {
      data: data
    }, rejectOnFalse ? null : _react().default.createElement("div", {
      className: (0, _css().cx)(_style.nodeSubtreeClass)
    }, _react().default.createElement("div", {
      className: (0, _css().cx)(_style.branchBlockClass, (0, _css().css)`
                > * > .workflow-branch-lines{
                  > button{
                    display: none;
                  }
                }
              `)
    }, _react().default.createElement(_Branch.Branch, {
      from: data,
      entry: falseEntry,
      branchIndex: 0
    }), _react().default.createElement(_Branch.Branch, {
      from: data,
      entry: trueEntry,
      branchIndex: 1
    })), _react().default.createElement("div", {
      className: (0, _css().css)`
                position: relative;
                height: 2em;
                overflow: visible;

                > span{
                  position: absolute;
                  top: calc(1.5em - 1px);
                  line-height: 1em;
                  color: #999;
                  background-color: #f0f2f5;
                  padding: 1px;
                }
              `
    }, _react().default.createElement("span", {
      className: (0, _css().css)`right: 4em;`
    }, _client().i18n.t('No')), _react().default.createElement("span", {
      className: (0, _css().css)`left: 4em;`
    }, _client().i18n.t('Yes')))));
  },

  components: {
    CalculationConfig
  }
};
exports.default = _default;