"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JobButton = JobButton;
exports.Node = Node;
exports.NodeDefaultView = NodeDefaultView;
exports.RemoveButton = RemoveButton;
exports.instructions = void 0;
exports.useNodeContext = useNodeContext;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _react2() {
  const data = require("@formily/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/utils/client");

  _client = function _client() {
    return data;
  };

  return data;
}

function _client2() {
  const data = require("@nocobase/client");

  _client2 = function _client2() {
    return data;
  };

  return data;
}

var _style = require("../style");

var _AddButton = require("../AddButton");

var _FlowContext = require("../FlowContext");

var _calculation = _interopRequireDefault(require("./calculation"));

var _condition = _interopRequireDefault(require("./condition"));

var _parallel = _interopRequireDefault(require("./parallel"));

var _delay = _interopRequireDefault(require("./delay"));

var _query = _interopRequireDefault(require("./query"));

var _create = _interopRequireDefault(require("./create"));

var _update = _interopRequireDefault(require("./update"));

var _destroy = _interopRequireDefault(require("./destroy"));

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

;
const instructions = new (_client().Registry)();
exports.instructions = instructions;
instructions.register('condition', _condition.default);
instructions.register('parallel', _parallel.default);
instructions.register('calculation', _calculation.default);
instructions.register('delay', _delay.default);
instructions.register('query', _query.default);
instructions.register('create', _create.default);
instructions.register('update', _update.default);
instructions.register('destroy', _destroy.default);

function useUpdateAction() {
  const _useTranslation = (0, _reactI18next().useTranslation)(),
        t = _useTranslation.t;

  const form = (0, _react2().useForm)();
  const api = (0, _client2().useAPIClient)();
  const ctx = (0, _client2().useActionContext)();

  const _useResourceActionCon = (0, _client2().useResourceActionContext)(),
        refresh = _useResourceActionCon.refresh;

  const data = useNodeContext();

  const _useFlowContext = (0, _FlowContext.useFlowContext)(),
        workflow = _useFlowContext.workflow;

  return {
    run() {
      return _asyncToGenerator(function* () {
        if (workflow.executed) {
          _antd().message.error(t('Node in executed workflow cannot be modified'));

          return;
        } // TODO: how to do validation separately for each field? especially disabled for dynamic fields?
        // await form.submit();


        yield api.resource('flow_nodes', data.id).update({
          filterByTk: data.id,
          values: {
            title: form.values.title,
            config: form.values.config
          }
        });
        ctx.setVisible(false);
        refresh();
      })();
    }

  };
}

;

const NodeContext = _react().default.createContext(null);

function useNodeContext() {
  return (0, _react().useContext)(NodeContext);
}

function Node({
  data
}) {
  const instruction = instructions.get(data.type);
  return _react().default.createElement(NodeContext.Provider, {
    value: data
  }, _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeBlockClass)
  }, instruction.render ? instruction.render(data) : _react().default.createElement(NodeDefaultView, {
    data: data
  }), !instruction.endding ? _react().default.createElement(_AddButton.AddButton, {
    upstream: data
  }) : _react().default.createElement("div", {
    className: (0, _css().css)`
                flex-grow: 1;
                display: flex;
                flex-direction: column;
                align-items: center;
                justify-content: center;
                width: 1px;
                height: 6em;
                padding: 2em 0;
                background-color: #f0f2f5;

                .anticon{
                  font-size: 1.5em;
                  line-height: 100%;
                }
              `
  }, _react().default.createElement(_icons().CloseOutlined, null))));
}

function RemoveButton() {
  var _useFlowContext2;

  const _useTranslation2 = (0, _reactI18next().useTranslation)(),
        t = _useTranslation2.t;

  const api = (0, _client2().useAPIClient)();

  const _ref = (_useFlowContext2 = (0, _FlowContext.useFlowContext)()) !== null && _useFlowContext2 !== void 0 ? _useFlowContext2 : {},
        workflow = _ref.workflow,
        nodes = _ref.nodes,
        onNodeRemoved = _ref.onNodeRemoved;

  const current = useNodeContext();

  if (!workflow) {
    return null;
  }

  const resource = api.resource('workflows.nodes', workflow.id);

  function onRemove() {
    return _onRemove.apply(this, arguments);
  }

  function _onRemove() {
    _onRemove = _asyncToGenerator(function* () {
      function onOk() {
        return _onOk.apply(this, arguments);
      }

      function _onOk() {
        _onOk = _asyncToGenerator(function* () {
          const _yield$resource$destr = yield resource.destroy({
            filterByTk: current.id
          }),
                node = _yield$resource$destr.data.data;

          onNodeRemoved(node);
        });
        return _onOk.apply(this, arguments);
      }

      const hasBranches = !nodes.find(item => item.upstream === current && item.branchIndex != null);
      const message = hasBranches ? t('Are you sure you want to delete it?') : t('This node contains branches, deleting will also be preformed to them, are you sure?');

      _antd().Modal.confirm({
        title: t('Delete'),
        content: message,
        onOk
      });
    });
    return _onRemove.apply(this, arguments);
  }

  return workflow.executed ? null : _react().default.createElement(_antd().Button, {
    type: "text",
    shape: "circle",
    icon: _react().default.createElement(_icons().DeleteOutlined, null),
    onClick: onRemove,
    className: "workflow-node-remove-button"
  });
}

function JobButton() {
  var _useNodeContext;

  const _useTranslation3 = (0, _reactI18next().useTranslation)(),
        t = _useTranslation3.t;

  const compile = (0, _client2().useCompile)();

  const _useFlowContext3 = (0, _FlowContext.useFlowContext)(),
        execution = _useFlowContext3.execution;

  const _ref2 = (_useNodeContext = useNodeContext()) !== null && _useNodeContext !== void 0 ? _useNodeContext : {},
        id = _ref2.id,
        type = _ref2.type,
        title = _ref2.title,
        job = _ref2.job;

  if (!execution) {
    return null;
  }

  if (!job) {
    return _react().default.createElement("span", {
      className: (0, _css().cx)('workflow-node-job-button', (0, _css().css)`
          border: 2px solid #d9d9d9;
          border-radius: 50%;
        `)
    });
  }

  const instruction = instructions.get(type);
  const _JobStatusOptionsMap$ = _constants.JobStatusOptionsMap[job.status],
        value = _JobStatusOptionsMap$.value,
        icon = _JobStatusOptionsMap$.icon,
        color = _JobStatusOptionsMap$.color;
  return _react().default.createElement(_client2().SchemaComponent, {
    schema: {
      type: 'void',
      properties: {
        [job.id]: {
          type: 'void',
          'x-component': 'Action',
          'x-component-props': {
            title: icon,
            shape: 'circle',
            className: ['workflow-node-job-button', (0, _css().css)`
                background-color: ${color};
                &:hover,&:focus{
                  background-color: ${color}
                }
              `]
          },
          properties: {
            [job.id]: {
              type: 'void',
              'x-decorator': 'Form',
              'x-decorator-props': {
                initialValue: job
              },
              'x-component': 'Action.Modal',
              title: _react().default.createElement("div", {
                className: (0, _css().cx)(_style.nodeTitleClass)
              }, _react().default.createElement(_antd().Tag, null, compile(instruction.title)), _react().default.createElement("strong", null, title), _react().default.createElement("span", {
                className: "workflow-node-id"
              }, "#", id)),
              properties: {
                status: {
                  type: 'number',
                  title: '{{t("Status")}}',
                  'x-decorator': 'FormItem',
                  'x-component': 'Select',
                  enum: _constants.JobStatusOptions,
                  'x-read-pretty': true
                },
                updatedAt: {
                  type: 'string',
                  title: '{{t("Executed at")}}',
                  'x-decorator': 'FormItem',
                  'x-component': 'DatePicker',
                  'x-component-props': {
                    showTime: true
                  },
                  'x-read-pretty': true
                },
                result: {
                  type: 'object',
                  title: '{{t("Node result")}}',
                  'x-decorator': 'FormItem',
                  'x-component': 'Input.JSON',
                  'x-component-props': {
                    className: (0, _css().css)`
                        padding: 1em;
                        background-color: #eee;
                      `
                  },
                  'x-read-pretty': true
                }
              }
            }
          }
        }
      }
    }
  });
}

function NodeDefaultView(props) {
  var _useFlowContext4;

  const compile = (0, _client2().useCompile)();

  const _ref3 = (_useFlowContext4 = (0, _FlowContext.useFlowContext)()) !== null && _useFlowContext4 !== void 0 ? _useFlowContext4 : {},
        workflow = _ref3.workflow;

  if (!workflow) {
    return null;
  }

  const data = props.data,
        children = props.children;
  const instruction = instructions.get(data.type);
  const detailText = workflow.executed ? '{{t("View")}}' : '{{t("Configure")}}';
  return _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeClass, `workflow-node-type-${data.type}`)
  }, _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeCardClass)
  }, _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeHeaderClass)
  }, _react().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeMetaClass)
  }, _react().default.createElement(_antd().Tag, null, compile(instruction.title))), _react().default.createElement("h4", {
    className: (0, _css().cx)(_style.nodeTitleClass)
  }, _react().default.createElement("strong", null, data.title), _react().default.createElement("span", {
    className: "workflow-node-id"
  }, "#", data.id)), _react().default.createElement(RemoveButton, null), _react().default.createElement(JobButton, null)), _react().default.createElement(_client2().SchemaComponent, {
    scope: instruction.scope,
    components: instruction.components,
    schema: {
      type: 'void',
      properties: {
        view: instruction.view,
        config: {
          type: 'void',
          title: detailText,
          'x-component': 'Action.Link',
          'x-component-props': {
            type: 'primary'
          },
          properties: {
            [instruction.type]: {
              type: 'void',
              title: instruction.title,
              'x-component': 'Action.Drawer',
              'x-decorator': 'Form',
              'x-decorator-props': {
                useValues(options) {
                  const d = useNodeContext();
                  return (0, _client2().useRequest)(() => {
                    return Promise.resolve({
                      data: d
                    });
                  }, options);
                }

              },
              properties: {
                title: {
                  type: 'string',
                  name: 'title',
                  title: '{{t("Name")}}',
                  'x-decorator': 'FormItem',
                  'x-component': 'Input'
                },
                config: {
                  type: 'void',
                  name: 'config',
                  'x-component': 'fieldset',
                  'x-component-props': {
                    disabled: workflow.executed,
                    className: (0, _css().css)`
                            .ant-select,
                            .ant-cascader-picker,
                            .ant-picker,
                            .ant-input-number,
                            .ant-input-affix-wrapper{
                              width: auto;
                              min-width: 6em;
                            }
                          `
                  },
                  properties: instruction.fieldset
                },
                actions: {
                  type: 'void',
                  'x-component': 'Action.Drawer.Footer',
                  properties: workflow.executed ? {
                    close: {
                      title: '{{t("Close")}}',
                      'x-component': 'Action',
                      'x-component-props': {
                        useAction: '{{ cm.useCancelAction }}'
                      }
                    }
                  } : {
                    cancel: {
                      title: '{{t("Cancel")}}',
                      'x-component': 'Action',
                      'x-component-props': {
                        useAction: '{{ cm.useCancelAction }}'
                      }
                    },
                    submit: {
                      title: '{{t("Submit")}}',
                      'x-component': 'Action',
                      'x-component-props': {
                        type: 'primary',
                        useAction: useUpdateAction
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  })), children);
}