"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _2 = require(".");

var _Branch = require("../Branch");

var _FlowContext = require("../FlowContext");

var _style = require("../style");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _default = {
  title: '{{t("Parallel branch")}}',
  type: 'parallel',
  group: 'control',
  fieldset: {
    'config.mode': {
      type: 'string',
      name: 'config.mode',
      title: '{{t("Mode")}}',
      'x-decorator': 'FormItem',
      'x-component': 'Radio.Group',
      'x-component-props': {},
      enum: [{
        value: 'all',
        label: _react().default.createElement(_antd().Tooltip, {
          title: _client().i18n.t('Continue after all branches succeeded'),
          placement: "bottom"
        }, _client().i18n.t('All succeeded'), " ", _react().default.createElement(_icons().QuestionCircleOutlined, {
          style: {
            color: '#999'
          }
        }))
      }, {
        value: 'any',
        label: _react().default.createElement(_antd().Tooltip, {
          title: _client().i18n.t('Continue after any branch succeeded'),
          placement: "bottom"
        }, _client().i18n.t('Any succeeded'), " ", _react().default.createElement(_icons().QuestionCircleOutlined, {
          style: {
            color: '#999'
          }
        }))
      }, {
        value: 'race',
        label: _react().default.createElement(_antd().Tooltip, {
          title: _client().i18n.t('Continue after any branch succeeded, or exit after any branch failed'),
          placement: "bottom"
        }, _client().i18n.t('Any succeeded or failed'), " ", _react().default.createElement(_icons().QuestionCircleOutlined, {
          style: {
            color: '#999'
          }
        }))
      }],
      default: 'all'
    }
  },
  view: {},

  render(data) {
    const id = data.id,
          mode = data.config.mode;

    const _useTranslation = (0, _reactI18next().useTranslation)(),
          t = _useTranslation.t;

    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
          nodes = _useFlowContext.nodes;

    const branches = nodes.reduce((result, node) => {
      if (node.upstreamId === id && node.branchIndex != null) {
        return result.concat(node);
      }

      return result;
    }, []).sort((a, b) => a.branchIndex - b.branchIndex);

    const _useState = (0, _react().useState)(Math.max(2, branches.length)),
          _useState2 = _slicedToArray(_useState, 2),
          branchCount = _useState2[0],
          setBranchCount = _useState2[1];

    const tempBranches = Array(Math.max(0, branchCount - branches.length)).fill(null);
    const lastBranchHead = branches[branches.length - 1];
    return _react().default.createElement(_2.NodeDefaultView, {
      data: data
    }, _react().default.createElement("div", {
      className: (0, _css().cx)(_style.nodeSubtreeClass)
    }, _react().default.createElement("div", {
      className: (0, _css().cx)(_style.branchBlockClass)
    }, branches.map(branch => _react().default.createElement(_Branch.Branch, {
      key: branch.id,
      from: data,
      entry: branch,
      branchIndex: branch.branchIndex
    })), tempBranches.map((_, i) => _react().default.createElement(_Branch.Branch, {
      key: `temp_${branches.length + i}`,
      from: data,
      branchIndex: (lastBranchHead ? lastBranchHead.branchIndex : 0) + i + 1,
      controller: branches.length + i > 1 ? _react().default.createElement("div", {
        className: (0, _css().css)`
                        padding-top: 2em;

                        > button{
                          .anticon{
                            transform: rotate(45deg)
                          }
                        }
                      `
      }, _react().default.createElement(_antd().Button, {
        shape: "circle",
        icon: _react().default.createElement(_icons().PlusOutlined, null),
        onClick: () => setBranchCount(branchCount - 1)
      })) : null
    }))), _react().default.createElement("div", {
      className: (0, _css().css)`
              position: relative;
              height: 2em;
            `
    }, _react().default.createElement(_antd().Tooltip, {
      title: t('Add branch')
    }, _react().default.createElement(_antd().Button, {
      icon: _react().default.createElement(_icons().PlusOutlined, null),
      className: (0, _css().css)`
                  position: absolute;
                  top: calc(50% - 1px);
                  transform: translateX(-50%) rotate(45deg);

                  .anticon{
                    transform: rotate(-45deg);
                  }
                `,
      onClick: () => setBranchCount(branchCount + 1)
    })))));
  }

};
exports.default = _default;