"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _FlowContext = require("../FlowContext");

var _calculators = require("../calculators");

var _collection = require("../schemas/collection");

var _CollectionFieldSelect = _interopRequireDefault(require("../components/CollectionFieldSelect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = {
  title: '{{t("Query record")}}',
  type: 'query',
  group: 'collection',
  fieldset: {
    'config.collection': _collection.collection,
    'config.multiple': {
      type: 'boolean',
      title: '{{t("Multiple records")}}',
      name: 'config.multiple',
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox',
      'x-component-props': {
        disabled: true
      }
    },
    'config.params': {
      type: 'object',
      name: 'config.params',
      title: '',
      'x-decorator': 'FormItem',
      properties: {
        filter: _collection.filter
      }
    }
  },
  view: {},
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    VariableComponent: _calculators.VariableComponent
  },

  getter(props) {
    const type = props.type,
          options = props.options,
          _onChange = props.onChange;

    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
          nodes = _useFlowContext.nodes;

    const _nodes$find = nodes.find(n => n.id == options.nodeId),
          config = _nodes$find.config;

    const value = options === null || options === void 0 ? void 0 : options.path;
    return _react().default.createElement(_CollectionFieldSelect.default, {
      collection: config.collection,
      value: value,
      onChange: path => {
        _onChange({
          type,
          options: _objectSpread(_objectSpread({}, options), {}, {
            path
          })
        });
      }
    });
  }

};
exports.default = _default;