"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.values = exports.filter = exports.collection = void 0;

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _react() {
  const data = require("@formily/react");

  _react = function _react() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

const collection = {
  type: 'string',
  title: '{{t("Collection")}}',
  name: 'config.collection',
  required: true,
  'x-reactions': ['{{useCollectionDataSource()}}'],
  'x-decorator': 'FormItem',
  'x-component': 'Select',
  'x-component-props': {
    placeholder: '{{t("Select collection")}}'
  }
};
exports.collection = collection;
const values = {
  type: 'object',
  title: '{{t("Fields values")}}',
  name: 'config.params.values',
  'x-decorator': 'FormItem',
  'x-decorator-props': {
    labelAlign: 'left',
    className: (0, _css().css)`
      flex-direction: column;
    `
  },
  'x-component': 'CollectionFieldset',
  description: '{{t("Fields that are not assigned a value will be set to the default value, and those that do not have a default value are set to null.")}}'
};
exports.values = values;
const filter = {
  type: 'object',
  title: '{{t("Filter")}}',
  name: 'config.params.filter',
  'x-decorator': 'FormItem',
  'x-decorator-props': {
    labelAlign: 'left',
    className: (0, _css().css)`
      flex-direction: column;
    `
  },
  'x-component': 'Filter',
  'x-component-props': {
    useProps() {
      var _values$config;

      const _useForm = (0, _react().useForm)(),
            values = _useForm.values;

      const options = (0, _client().useCollectionFilterOptions)((_values$config = values.config) === null || _values$config === void 0 ? void 0 : _values$config.collection);
      return {
        options,
        className: (0, _css().css)`
          position: relative;
          width: 100%;
        `
      };
    },

    dynamicComponent: 'VariableComponent'
  }
};
exports.filter = filter;