"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.executionSchema = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function _reactRouterDom() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const collection = {
  name: 'executions',
  fields: [{
    interface: 'createdAt',
    type: 'datetime',
    // field: 'createdAt',
    name: 'createdAt',
    uiSchema: {
      type: 'datetime',
      title: '{{t("Triggered at")}}',
      'x-component': 'DatePicker',
      'x-component-props': {},
      'x-read-pretty': true
    }
  }, {
    interface: 'object',
    type: 'belongsTo',
    name: 'workflowId',
    uiSchema: {
      type: 'number',
      title: '{{t("Version")}}',

      ['x-component']({
        value
      }) {
        const _useActionContext = (0, _client().useActionContext)(),
              setVisible = _useActionContext.setVisible;

        return _react().default.createElement(_reactRouterDom().Link, {
          to: `/admin/settings/workflow/workflows/${value}`,
          onClick: () => setVisible(false)
        }, `#${value}`);
      }

    }
  }, {
    type: 'number',
    name: 'status',
    interface: 'select',
    uiSchema: {
      title: '{{t("Status")}}',
      type: 'string',
      'x-component': 'Select',
      'x-decorator': 'FormItem',
      enum: _constants.ExecutionStatusOptions
    }
  }]
};
const executionSchema = {
  provider: {
    type: 'void',
    'x-decorator': 'ExecutionResourceProvider',
    'x-decorator-props': {
      collection,
      resourceName: 'executions',
      request: {
        resource: 'executions',
        action: 'list',
        params: {
          appends: ['workflow.id', 'workflow.title'],
          pageSize: 50,
          sort: ['-createdAt']
        }
      }
    },
    'x-component': 'CollectionProvider',
    'x-component-props': {
      collection
    },
    properties: {
      actions: {
        type: 'void',
        'x-component': 'ActionBar',
        'x-component-props': {
          style: {
            marginBottom: 16
          }
        },
        properties: {// filter: {
          //   type: 'object',
          //   'x-component': 'Filter',
          // }
        }
      },
      table: {
        type: 'void',
        'x-component': 'Table.Void',
        'x-component-props': {
          rowKey: 'id',
          useDataSource: '{{ cm.useDataSourceFromRAC }}'
        },
        properties: {
          createdAt: {
            type: 'void',
            'x-decorator': 'Table.Column.Decorator',
            'x-component': 'Table.Column',
            properties: {
              createdAt: {
                type: 'datetime',
                'x-component': 'CollectionField',
                'x-component-props': {
                  showTime: true
                },
                'x-read-pretty': true
              }
            }
          },
          workflowId: {
            type: 'void',
            'x-decorator': 'Table.Column.Decorator',
            'x-component': 'Table.Column',
            properties: {
              workflowId: {
                type: 'number',
                'x-component': 'CollectionField',
                'x-read-pretty': true
              }
            }
          },
          status: {
            type: 'void',
            'x-decorator': 'Table.Column.Decorator',
            'x-component': 'Table.Column',
            properties: {
              status: {
                type: 'number',
                'x-component': 'CollectionField',
                'x-read-pretty': true
              }
            }
          },
          actions: {
            type: 'void',
            title: '{{ t("Actions") }}',
            'x-component': 'Table.Column',
            properties: {
              actions: {
                type: 'void',
                'x-component': 'Space',
                'x-component-props': {
                  split: '|'
                },
                properties: {
                  config: {
                    type: 'void',
                    title: '{{t("Details")}}',
                    'x-component': 'ExecutionLink'
                  }
                }
              }
            }
          }
        }
      }
    }
  }
};
exports.executionSchema = executionSchema;