"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _react2() {
  const data = require("@formily/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _FlowContext = require("../FlowContext");

var _collection = require("../schemas/collection");

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _core() {
  const data = require("@formily/core");

  _core = function _core() {
    return data;
  };

  return data;
}

var _CollectionFieldSelect = _interopRequireDefault(require("../components/CollectionFieldSelect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const FieldsSelect = (0, _react2().observer)(props => {
  var _values$config;

  const compile = (0, _client().useCompile)();

  const _useCollectionManager = (0, _client().useCollectionManager)(),
        getCollectionFields = _useCollectionManager.getCollectionFields;

  const _useForm = (0, _react2().useForm)(),
        values = _useForm.values,
        clearFormGraph = _useForm.clearFormGraph,
        setValuesIn = _useForm.setValuesIn;

  const fields = getCollectionFields(values === null || values === void 0 ? void 0 : (_values$config = values.config) === null || _values$config === void 0 ? void 0 : _values$config.collection);
  (0, _react2().useFormEffects)(() => {
    (0, _core().onFieldValueChange)('config.collection', field => {
      clearFormGraph('config.changed');
      setValuesIn('config.condition', null);
    });
  });
  return _react().default.createElement(_antd().Select, _objectSpread(_objectSpread({}, props), {}, {
    className: (0, _css().css)`
        min-width: 6em;
      `
  }), fields.filter(field => !field.hidden && (field.uiSchema ? !field.uiSchema['x-read-pretty'] : true) && !['linkTo', 'hasOne', 'hasMany', 'belongsToMany'].includes(field.type)).map(field => {
    var _field$uiSchema;

    return _react().default.createElement(_antd().Select.Option, {
      key: field.name,
      value: field.name
    }, compile((_field$uiSchema = field.uiSchema) === null || _field$uiSchema === void 0 ? void 0 : _field$uiSchema.title));
  }));
});
var _default = {
  title: '{{t("Collection event")}}',
  type: 'collection',
  fieldset: {
    'config.collection': _objectSpread(_objectSpread({}, _collection.collection), {}, {
      ['x-reactions']: [..._collection.collection['x-reactions'], {
        target: 'config.mode',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }, {
        target: 'config.changed',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }, {
        target: 'config.condition',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }]
    }),
    'config.mode': {
      type: 'number',
      title: '{{t("Trigger on")}}',
      name: 'config.mode',
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        options: [{
          value: 1,
          label: '{{t("After record added")}}'
        }, {
          value: 2,
          label: '{{t("After record updated")}}'
        }, {
          value: 3,
          label: '{{t("After record added or updated")}}'
        }, {
          value: 4,
          label: '{{t("After record deleted")}}'
        }],
        placeholder: '{{t("Trigger on")}}'
      },
      required: true,
      'x-reactions': [{
        target: 'config.changed',
        fulfill: {
          state: {
            disabled: '{{!($self.value & 0b010)}}'
          }
        }
      }]
    },
    'config.changed': {
      type: 'array',
      name: 'changed',
      title: '{{t("Changed fields")}}',
      description: '{{t("Triggered only if one of the selected fields changes. If unselected, it means that it will be triggered when any field changes. When record is added or deleted, any field is considered to have been changed.")}}',
      'x-decorator': 'FormItem',
      'x-component': 'FieldsSelect',
      'x-component-props': {
        mode: 'multiple',
        placeholder: '{{t("Select Field")}}'
      }
    },
    'config.condition': _objectSpread(_objectSpread({}, _collection.filter), {}, {
      name: 'config.condition',
      title: '{{t("Only triggers when match conditions")}}'
    })
  },
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    FieldsSelect
  },

  getter(props) {
    var _options$path;

    const type = props.type,
          options = props.options,
          _onChange = props.onChange;

    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
          workflow = _useFlowContext.workflow;

    const value = options === null || options === void 0 ? void 0 : (_options$path = options.path) === null || _options$path === void 0 ? void 0 : _options$path.replace(/^data\./, '');
    return _react().default.createElement(_CollectionFieldSelect.default, {
      collection: workflow.config.collection,
      value: value,
      onChange: value => {
        _onChange({
          type,
          options: _objectSpread(_objectSpread({}, options), {}, {
            path: `data.${value}`
          })
        });
      }
    });
  }

};
exports.default = _default;