"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.triggers = exports.TriggerConfig = void 0;

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _react() {
  const data = require("@formily/react");

  _react = function _react() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/utils/client");

  _client = function _client() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _react2() {
  const data = _interopRequireDefault(require("react"));

  _react2 = function _react2() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _client2() {
  const data = require("@nocobase/client");

  _client2 = function _client2() {
    return data;
  };

  return data;
}

var _style = require("../style");

var _FlowContext = require("../FlowContext");

var _collection = _interopRequireDefault(require("./collection"));

var _schedule = _interopRequireDefault(require("./schedule/"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function useUpdateConfigAction() {
  var _useFlowContext;

  const _useTranslation = (0, _reactI18next().useTranslation)(),
        t = _useTranslation.t;

  const form = (0, _react().useForm)();
  const api = (0, _client2().useAPIClient)();

  const _ref = (_useFlowContext = (0, _FlowContext.useFlowContext)()) !== null && _useFlowContext !== void 0 ? _useFlowContext : {},
        workflow = _ref.workflow;

  const ctx = (0, _client2().useActionContext)();

  const _useResourceActionCon = (0, _client2().useResourceActionContext)(),
        refresh = _useResourceActionCon.refresh;

  return {
    run() {
      return _asyncToGenerator(function* () {
        if (workflow.executed) {
          _antd().message.error(t('Trigger in executed workflow cannot be modified'));

          return;
        }

        yield form.submit();
        yield api.resource('workflows').update({
          filterByTk: workflow.id,
          values: form.values
        });
        ctx.setVisible(false);
        refresh();
      })();
    }

  };
}

;
;
const triggers = new (_client().Registry)();
exports.triggers = triggers;
triggers.register(_collection.default.type, _collection.default);
triggers.register(_schedule.default.type, _schedule.default);

function TriggerExecution() {
  const compile = (0, _client2().useCompile)();

  const _useFlowContext2 = (0, _FlowContext.useFlowContext)(),
        workflow = _useFlowContext2.workflow,
        execution = _useFlowContext2.execution;

  if (!execution) {
    return null;
  }

  const trigger = triggers.get(workflow.type);
  return _react2().default.createElement(_client2().SchemaComponent, {
    schema: {
      type: 'void',
      properties: {
        trigger: {
          type: 'void',
          'x-component': 'Action',
          'x-component-props': {
            title: _react2().default.createElement(_icons().InfoOutlined, null),
            shape: 'circle',
            className: 'workflow-node-job-button',
            type: 'primary'
          },
          properties: {
            [execution.id]: {
              type: 'void',
              'x-decorator': 'Form',
              'x-decorator-props': {
                initialValue: execution
              },
              'x-component': 'Action.Modal',
              title: _react2().default.createElement("div", {
                className: (0, _css().cx)(_style.nodeTitleClass)
              }, _react2().default.createElement(_antd().Tag, null, compile(trigger.title)), _react2().default.createElement("strong", null, workflow.title), _react2().default.createElement("span", {
                className: "workflow-node-id"
              }, "#", execution.id)),
              properties: {
                createdAt: {
                  type: 'string',
                  title: '{{t("Triggered at")}}',
                  'x-decorator': 'FormItem',
                  'x-component': 'DatePicker',
                  'x-component-props': {
                    showTime: true
                  },
                  'x-read-pretty': true
                },
                context: {
                  type: 'object',
                  title: '{{t("Trigger context")}}',
                  'x-decorator': 'FormItem',
                  'x-component': 'Input.JSON',
                  'x-component-props': {
                    className: (0, _css().css)`
                        padding: 1em;
                        background-color: #eee;
                      `
                  },
                  'x-read-pretty': true
                }
              }
            }
          }
        }
      }
    }
  });
}

const TriggerConfig = () => {
  const _useTranslation2 = (0, _reactI18next().useTranslation)(),
        t = _useTranslation2.t;

  const compile = (0, _client2().useCompile)();

  const _useFlowContext3 = (0, _FlowContext.useFlowContext)(),
        workflow = _useFlowContext3.workflow;

  if (!workflow || !workflow.type) {
    return null;
  }

  const type = workflow.type,
        config = workflow.config,
        executed = workflow.executed;

  const _triggers$get = triggers.get(type),
        title = _triggers$get.title,
        fieldset = _triggers$get.fieldset,
        scope = _triggers$get.scope,
        components = _triggers$get.components;

  const detailText = executed ? '{{t("View")}}' : '{{t("Configure")}}';
  const titleText = `${t('Trigger')}: ${compile(title)}`;
  return _react2().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeCardClass)
  }, _react2().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeHeaderClass)
  }, _react2().default.createElement("div", {
    className: (0, _css().cx)(_style.nodeMetaClass)
  }, _react2().default.createElement(_antd().Tag, {
    color: "gold"
  }, t('Trigger'))), _react2().default.createElement("h4", null, compile(title)), _react2().default.createElement(TriggerExecution, null)), _react2().default.createElement(_client2().SchemaComponent, {
    schema: {
      type: 'void',
      title: detailText,
      'x-component': 'Action.Link',
      name: 'drawer',
      properties: {
        drawer: {
          type: 'void',
          title: titleText,
          'x-component': 'Action.Drawer',
          'x-decorator': 'Form',
          'x-decorator-props': {
            useValues(options) {
              return (0, _client2().useRequest)(() => Promise.resolve({
                data: {
                  config
                }
              }), options);
            }

          },
          properties: {
            config: {
              type: 'void',
              name: 'config',
              'x-component': 'fieldset',
              'x-component-props': {
                className: (0, _css().css)`
                      .ant-select{
                        width: auto;
                        min-width: 6em;
                      }
                    `
              },
              properties: fieldset
            },
            actions: {
              type: 'void',
              'x-component': 'Action.Drawer.Footer',
              properties: executed ? {
                close: {
                  title: '{{t("Close")}}',
                  'x-component': 'Action',
                  'x-component-props': {
                    useAction: '{{ cm.useCancelAction }}'
                  }
                }
              } : {
                cancel: {
                  title: '{{t("Cancel")}}',
                  'x-component': 'Action',
                  'x-component-props': {
                    useAction: '{{ cm.useCancelAction }}'
                  }
                },
                submit: {
                  title: '{{t("Submit")}}',
                  'x-component': 'Action',
                  'x-component-props': {
                    type: 'primary',
                    useAction: useUpdateConfigAction
                  }
                }
              }
            }
          }
        }
      }
    },
    scope: scope,
    components: components
  }));
};

exports.TriggerConfig = TriggerConfig;