"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScheduleConfig = void 0;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _core() {
  const data = require("@formily/core");

  _core = function _core() {
    return data;
  };

  return data;
}

function _react2() {
  const data = require("@formily/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

function _css() {
  const data = require("@emotion/css");

  _css = function _css() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _collection = require("../../schemas/collection");

var _OnField = require("./OnField");

var _EndsByField = require("./EndsByField");

var _RepeatField = require("./RepeatField");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const ModeFieldsets = {
  0: {
    startsOn: {
      type: 'datetime',
      name: 'startsOn',
      title: '{{t("Starts on")}}',
      'x-decorator': 'FormItem',
      'x-component': 'DatePicker',
      'x-component-props': {
        showTime: true
      },
      required: true
    },
    repeat: {
      type: 'string',
      name: 'repeat',
      title: '{{t("Repeat mode")}}',
      'x-decorator': 'FormItem',
      'x-component': 'RepeatField',
      'x-reactions': [{
        target: 'config.endsOn',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }, {
        target: 'config.limit',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }]
    },
    endsOn: {
      type: 'datetime',
      name: 'endsOn',
      title: '{{t("Ends on")}}',
      'x-decorator': 'FormItem',
      'x-component': 'DatePicker',
      'x-component-props': {
        showTime: true
      }
    },
    limit: {
      type: 'number',
      name: 'limit',
      title: '{{t("Repeat limit")}}',
      'x-decorator': 'FormItem',
      'x-component': 'InputNumber',
      'x-component-props': {
        placeholder: '{{t("No limit")}}',
        min: 0
      }
    }
  },
  1: {
    collection: _objectSpread(_objectSpread({}, _collection.collection), {}, {
      'x-reactions': [..._collection.collection['x-reactions'], {
        // only full path works
        target: 'config.startsOn',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }]
    }),
    startsOn: {
      type: 'object',
      title: '{{t("Starts on")}}',
      'x-decorator': 'FormItem',
      'x-component': 'OnField',
      'x-reactions': [{
        target: 'config.repeat',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }],
      required: true
    },
    repeat: {
      type: 'string',
      name: 'repeat',
      title: '{{t("Repeat mode")}}',
      'x-decorator': 'FormItem',
      'x-component': 'RepeatField',
      'x-reactions': [{
        target: 'config.endsOn',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }, {
        target: 'config.limit',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }]
    },
    endsOn: {
      type: 'object',
      title: '{{t("Ends on")}}',
      'x-decorator': 'FormItem',
      'x-component': 'EndsByField'
    },
    limit: {
      type: 'number',
      name: 'limit',
      title: '{{t("Repeat limit")}}',
      'x-decorator': 'FormItem',
      'x-component': 'InputNumber',
      'x-component-props': {
        placeholder: '{{t("No limit")}}',
        min: 0
      }
    }
  }
};

const ScheduleConfig = () => {
  const _useForm = (0, _react2().useForm)(),
        _useForm$values = _useForm.values,
        values = _useForm$values === void 0 ? {} : _useForm$values,
        clearFormGraph = _useForm.clearFormGraph;

  const _values$config = values.config,
        config = _values$config === void 0 ? {} : _values$config;

  const _useState = (0, _react().useState)(config.mode),
        _useState2 = _slicedToArray(_useState, 2),
        mode = _useState2[0],
        setMode = _useState2[1];

  (0, _react2().useFormEffects)(() => {
    (0, _core().onFieldValueChange)('config.mode', field => {
      setMode(field.value);
      clearFormGraph('config.collection');
      clearFormGraph('config.startsOn');
      clearFormGraph('config.repeat');
      clearFormGraph('config.endsOn');
      clearFormGraph('config.limit');
    });
  });
  return _react().default.createElement(_react().default.Fragment, null, _react().default.createElement(_client().SchemaComponent, {
    schema: {
      type: 'number',
      title: '{{t("Trigger mode")}}',
      name: 'mode',
      'x-decorator': 'FormItem',
      'x-component': 'Radio.Group',
      'x-component-props': {
        options: [{
          value: 0,
          label: '{{t("Based on certain date")}}'
        }, {
          value: 1,
          label: '{{t("Based on date field of collection")}}'
        }]
      },
      required: true
    }
  }), _react().default.createElement(_client().SchemaComponent, {
    schema: {
      type: 'void',
      properties: {
        [`mode-${mode}`]: {
          type: 'void',
          'x-component': 'fieldset',
          'x-component-props': {
            className: (0, _css().css)`
                  .ant-input-number{
                    width: 4em;
                  }

                  .ant-picker{
                    width: auto;
                  }
                `
          },
          properties: ModeFieldsets[mode]
        }
      }
    },
    components: {
      OnField: _OnField.OnField,
      RepeatField: _RepeatField.RepeatField,
      EndsByField: _EndsByField.EndsByField
    }
  }));
};

exports.ScheduleConfig = ScheduleConfig;