import { Transactionable } from '@nocobase/database';
import { Plugin } from '@nocobase/server';
import { Registry } from '@nocobase/utils';
import { Instruction } from './instructions';
import ExecutionModel from './models/Execution';
import WorkflowModel from './models/Workflow';
import Processor from './Processor';
import { Trigger } from './triggers';
export default class WorkflowPlugin extends Plugin {
    instructions: Registry<Instruction>;
    triggers: Registry<Trigger>;
    calculators: Registry<Function>;
    extensions: typeof import("./extensions/assignees").default[];
    onBeforeSave: (instance: WorkflowModel, options: any) => Promise<void>;
    load(): Promise<void>;
    toggle(workflow: WorkflowModel, enable?: boolean): void;
    trigger(workflow: WorkflowModel, context: Object, options?: Transactionable & {
        context?: any;
    }): Promise<ExecutionModel | null>;
    createProcessor(execution: ExecutionModel, options?: {}): Processor;
}
