"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.submit = submit;

function _actions() {
  const data = require("@nocobase/actions");

  _actions = function _actions() {
    return data;
  };

  return data;
}

var _constants = require("../../constants");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function submit(_x, _x2) {
  return _submit.apply(this, arguments);
}

function _submit() {
  _submit = _asyncToGenerator(function* (context, next) {
    const repository = _actions().utils.getRepositoryFromParams(context);

    const _context$action$param = context.action.params,
          filterByTk = _context$action$param.filterByTk,
          values = _context$action$param.values;
    const currentUser = context.state.currentUser;

    if (!currentUser) {
      return context.throw(401);
    }

    const instance = yield repository.findOne({
      filterByTk,
      // filter: {
      //   userId: currentUser?.id
      // },
      appends: ['job', 'node', 'execution'],
      context
    });
    const _instance$node$config = instance.node.config,
          actions = _instance$node$config.actions,
          assignees = _instance$node$config.assignees; // NOTE: validate status

    if (instance.status !== _constants.JOB_STATUS.PENDING || instance.job.status !== _constants.JOB_STATUS.PENDING || instance.execution.status !== _constants.EXECUTION_STATUS.STARTED || actions && !actions[values.status]) {
      context.throw(400);
    }

    if (!assignees.includes(currentUser.id) || instance.userId !== currentUser.id) {
      return context.throw(404);
    } // NOTE: validate assignee


    yield instance.update({
      status: values.status,
      result: values.result
    });
    context.body = instance;
    context.status = 202;
    yield next();
    instance.job.latestUserJob = instance;
    const plugin = context.app.pm.get('workflow');
    const processor = plugin.createProcessor(instance.execution); // NOTE: resume the process and no `await` for quick returning

    processor.resume(instance.job);
  });
  return _submit.apply(this, arguments);
}