import FlowNodeModel from '../models/FlowNode';
import Plugin from '..';
import Processor from '../Processor';
export declare type Job = {
    status: number;
    result?: unknown;
    [key: string]: unknown;
} | null;
export declare type InstructionResult = Job | Promise<Job>;
export interface Instruction {
    run(node: FlowNodeModel, input: any, processor: Processor): InstructionResult;
    resume?(node: FlowNodeModel, input: any, processor: Processor): InstructionResult;
}
declare type InstructionConstructor<T> = {
    new (p: Plugin): T;
};
export default function <T extends Instruction>(plugin: any, more?: {
    [key: string]: T | InstructionConstructor<T>;
}): void;
export {};
