"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _koaCompose() {
  const data = _interopRequireDefault(require("koa-compose"));

  _koaCompose = function _koaCompose() {
    return data;
  };

  return data;
}

function _actions() {
  const data = require("@nocobase/actions");

  _actions = function _actions() {
    return data;
  };

  return data;
}

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function loadJob(_x, _x2) {
  return _loadJob.apply(this, arguments);
}

function _loadJob() {
  _loadJob = _asyncToGenerator(function* (context, next) {
    const _context$action$param = context.action.params,
          filterByTk = _context$action$param.filterByTk,
          values = _context$action$param.values;

    if (!context.body) {
      const jobRepo = _actions().utils.getRepositoryFromParams(context);

      const job = yield jobRepo.findOne({
        filterByTk,
        appends: ['node', 'execution'],
        context
      });

      if (!filterByTk || !job) {
        return context.throw(404);
      } // cache


      context.body = job;
    }

    const _context$body$node = context.body.node,
          type = _context$body$node.type,
          config = _context$body$node.config;

    if (type === 'prompt' && config.actions && !config.actions[values.status]) {
      return context.throw(400);
    }

    yield next();
  });
  return _loadJob.apply(this, arguments);
}

class _default {
  constructor(plugin) {
    var _this = this;

    this.plugin = void 0;
    this.middlewares = [];

    this.middleware = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (context, next) {
        const _context$action = context.action,
              actionName = _context$action.actionName,
              resourceName = _context$action.resourceName;

        if (actionName === 'submit' && resourceName === 'jobs' && _this.middlewares.length) {
          return (0, _koaCompose().default)([loadJob, ..._this.middlewares])(context, next);
        }

        yield next();
      });

      return function (_x3, _x4) {
        return _ref.apply(this, arguments);
      };
    }();

    this.plugin = plugin;
    plugin.app.resourcer.use(this.middleware);
  }

  use(middleware) {
    this.middlewares.push(middleware);
  }

  run(node, input, processor) {
    return {
      status: _constants.JOB_STATUS.PENDING
    };
  }

  resume(node, job, processor) {
    if (!node.config.actions) {
      job.set('status', _constants.JOB_STATUS.RESOLVED);
    }

    return job;
  }

  extend(options) {
    Object.assign(this, options);
  }

}

exports.default = _default;
;