import { Database, Model } from '@nocobase/database';
import { BelongsToGetAssociationMixin, HasManyGetAssociationsMixin } from 'sequelize';
import WorkflowModel from './Workflow';
import JobModel from './Job';
export default class ExecutionModel extends Model {
    static readonly database: Database;
    id: number;
    title: string;
    context: any;
    status: number;
    useTransaction: boolean;
    transaction: string;
    createdAt: Date;
    updatedAt: Date;
    key: string;
    workflow?: WorkflowModel;
    getWorkflow: BelongsToGetAssociationMixin<WorkflowModel>;
    jobs?: JobModel[];
    getJobs: HasManyGetAssociationsMixin<JobModel>;
}
