"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ = require("..");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const MODE_BITMAP = {
  CREATE: 1,
  UPDATE: 2,
  DESTROY: 4
};
const MODE_BITMAP_EVENTS = new Map();
MODE_BITMAP_EVENTS.set(MODE_BITMAP.CREATE, 'afterCreateWithAssociations');
MODE_BITMAP_EVENTS.set(MODE_BITMAP.UPDATE, 'afterUpdateWithAssociations');
MODE_BITMAP_EVENTS.set(MODE_BITMAP.DESTROY, 'afterDestroy');

function getHookId(workflow, type) {
  return `${type}#${workflow.id}`;
}

function getFieldRawName(collection, name) {
  const field = collection.getField(name);

  if (field && field.type === 'belongsTo') {
    return field.foreignKey;
  }

  return name;
} // async function, should return promise


function handler(_x, _x2, _x3) {
  return _handler.apply(this, arguments);
}

function _handler() {
  _handler = _asyncToGenerator(function* (workflow, data, options) {
    var _condition$$and;

    const _workflow$config3 = workflow.config,
          collectionName = _workflow$config3.collection,
          condition = _workflow$config3.condition,
          changed = _workflow$config3.changed;
    const collection = data.constructor.database.getCollection(collectionName); // NOTE: if no configured fields changed, do not trigger

    if (changed && changed.length && changed.filter(name => !['linkTo', 'hasOne', 'hasMany', 'belongsToMany'].includes(collection.getField(name).type)).every(name => !data.changedWithAssociations(getFieldRawName(collection, name)))) {
      // TODO: temp comment out
      return;
    } // NOTE: if no configured condition match, do not trigger


    if (condition && ((_condition$$and = condition.$and) === null || _condition$$and === void 0 ? void 0 : _condition$$and.length)) {
      // TODO: change to map filter format to calculation format
      // const calculation = toCalculation(condition);
      const repository = collection.repository,
            model = collection.model;
      const transaction = options.transaction,
            context = options.context;
      const count = yield repository.count({
        filter: {
          $and: [condition, {
            [model.primaryKeyAttribute]: data[model.primaryKeyAttribute]
          }]
        },
        context,
        transaction
      });

      if (!count) {
        return;
      }
    }

    return this.plugin.trigger(workflow, {
      data: data.get()
    }, {
      context: options.context,
      transaction: options.transaction
    });
  });
  return _handler.apply(this, arguments);
}

class CollectionTrigger extends _.Trigger {
  constructor(...args) {
    super(...args);
    this.events = new Map();
  }

  on(workflow) {
    const db = this.plugin.app.db;
    const _workflow$config = workflow.config,
          collection = _workflow$config.collection,
          mode = _workflow$config.mode;
    const Collection = db.getCollection(collection);

    if (!Collection) {
      return;
    }

    var _iterator = _createForOfIteratorHelper(MODE_BITMAP_EVENTS.entries()),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        let _step$value = _slicedToArray(_step.value, 2),
            key = _step$value[0],
            type = _step$value[1];

        const event = `${collection}.${type}`;
        const name = getHookId(workflow, event);

        if (mode & key) {
          if (!this.events.has(name)) {
            const listener = handler.bind(this, workflow);
            this.events.set(name, listener);
            db.on(event, listener);
          }
        } else {
          const listener = this.events.get(name);

          if (listener) {
            db.off(event, listener);
            this.events.delete(name);
          }
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }

  off(workflow) {
    const db = this.plugin.app.db;
    const _workflow$config2 = workflow.config,
          collection = _workflow$config2.collection,
          mode = _workflow$config2.mode;
    const Collection = db.getCollection(collection);

    if (!Collection) {
      return;
    }

    var _iterator2 = _createForOfIteratorHelper(MODE_BITMAP_EVENTS.entries()),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        let _step2$value = _slicedToArray(_step2.value, 2),
            key = _step2$value[0],
            type = _step2$value[1];

        const event = `${collection}.${type}`;
        const name = getHookId(workflow, event);

        if (mode & key) {
          const listener = this.events.get(name);

          if (listener) {
            db.off(event, listener);
            this.events.delete(name);
          }
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }

}

exports.default = CollectionTrigger;