import Plugin, { Trigger } from '..';
export declare type ScheduleOnField = string | {
    field: string;
    offset?: number;
    unit?: 1000 | 60000 | 3600000 | 86400000;
};
export interface ScheduleTriggerConfig {
    mode: number;
    repeat?: string | number | null;
    limit?: number;
    startsOn?: ScheduleOnField;
    endsOn?: ScheduleOnField;
}
export declare const SCHEDULE_MODE: {
    readonly CONSTANT: 0;
    readonly COLLECTION_FIELD: 1;
};
declare function matchNext(this: ScheduleTrigger, workflow: any, now: Date, range?: number): boolean;
export default class ScheduleTrigger extends Trigger {
    static CacheRules: (typeof matchNext | ((workflow: any, now: any) => any))[];
    static TriggerRules: ((workflow: any, now: any) => any)[];
    events: Map<any, any>;
    private timer;
    private cache;
    interval: number;
    cacheCycle: number;
    constructor(plugin: Plugin);
    init(): void;
    run: () => void;
    onTick(now: any): Promise<any>;
    reload(): Promise<void>;
    inspect(workflows: any): void;
    setCache(workflow: any, out?: boolean): void;
    shouldCache(workflow: any, now: any): Promise<boolean>;
    shouldTrigger(workflow: any, now: any): boolean;
    trigger(workflow: any, date: Date): Promise<any>;
    on(workflow: any): void;
    off(workflow: any): void;
}
export {};
